q3k's Pullstruder
===

PET bottle recycling machine. Based on the [Recreator3d](http://recreator3d.com/) by Joshua R. Taylor, but with a few twists.

Work in progress.


Electronics
===

Mainboard is a Melzi 'v5.0' with an ATMega1284P. Reused from a TRONXY X1.

Schematic of 2.0: https://reprap.org/mediawiki/images/7/7d/Melzi-circuit.png

EXP connector:
----

On the mainboard:

    PC1 | 1  2 | PA1
    PC0 | 3  4 | PA2
    PD3 | 5  6 | PA3
    PD2 | 7  8 | PA4
    VCC | 9 10 | GND

LCD board
---

| EXP Pin | AVR Pin | AVR Function | Screen board function |
|---------|---------|--------------|-----------------------|
| 1       | PC1     | I2C SDA      | LCD D7                |
| 2       | PA1     | ADC1         | Button Matrix         |
| 3       | PC0     | I2C SCL      | LCD D6                |
| 4       | PA2     | ADC2         | LCD EN                |
| 5       | PD3     | INT1         | LCD D5                |
| 6       | PA3     | ADC3         | LCD RS                |
| 7       | PD2     | INT0         | LCD D4                |
| 8       | PA4     | ADC4         | Unused?               |

Button Matrix
---

On the LCD board.

Based on a voltage divider between button(s) pressed and a constant pull-up to VCC.

Resistor to VCC: 4.7k

| Button | Resistor to GND | Voltage when pressed (VCC=5V) | ADC Value |
|--------|-----------------|-------------------------------|-----------|
| Left   | 470             | 0.45V                         | 93        |
| Down   | 1k              | 0.87V                         | 180       |
| Menu   | 2.2k            | 1.6V                          | 326       |
| Right  | 4.7k            | 2.5V                          | 512       |
| Up     | 10k             | 3.4V                          | 697       |


Firmware
===

In progress, written in Rust. Aims to be purpose-specific and not just a repurposed 3D printer control firmware.
